<?php

class Vifito_Filter_UnhyphenateTest extends PHPUnit_Framework_TestCase
{
    /**
     * Vifito_Filter_Unhyphenate object
     *
     * @var Vifito_Filter_Unhyphenate
     */
    protected $_filter;
    
    protected $_data = array(
        'q-id-7' => 'Value for [q][id][7]',
        'q-id-8' => 'Value for [q][id][7]',
        'x-data' => 'Value for [x][data]',
        'y-data' => 'Value for [y][data]',
        'z' => false,
    );

    /**
     * Creates a new Zend_Filter_StringTrim object for each test method
     *
     * @return void
     */
    public function setUp()
    {
        $this->_filter = new Vifito_Filter_Unhyphenate();
    }
    
    public function testNull()
    {
        $this->assertEquals(null, $this->_filter->filter(null));
    }
    
    public function testNoArray()
    {
        $this->assertEquals(1, $this->_filter->filter(1));
        $this->assertEquals("String", $this->_filter->filter("String"));
        $this->assertEquals(true, $this->_filter->filter(true));
    }
    
    public function testArrayEntry()
    {
        $filteredData = $this->_filter->filter($this->_data);
        $this->assertEquals('Value for [q][id][7]', $filteredData['q']['id'][7], 'Test entrada anidada');        
    }
    
    public function testArraySimpleEntry()
    {
        $filteredData = $this->_filter->filter($this->_data);
        $this->assertEquals(false, $filteredData['z'], 'Test entrada simple');
    }
    
    
}